/***************************************************
 *                                                 *
 *    Macro Assembler				   *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#define DTITLE "80386 Macro V2.0"

/* iAPX386 is a mit style assembler */
#define MITASM
/* iAPX386 is a little indian machine */
#define LITTLE
/* iAPX386 supports flexable names */
#define FLEXNAMES
/* iAPX386 is a 32 bit address machine */
#define ADDRSZ 8
#define iAPX386
#define CPU_TYPE	01
#define ALIGN	0

/* Addressing modes */
#define  MABS 	0x000		/* expr */
#define  MIND	0x100		/* seg:off(lreg) */
#define  MTWO	0x200		/* seg:off(lreg,lreg[,s]) */
#define  MINX	0x300		/* seg:off(,lreg[,s]) */
#define  MI16	0x400		/* seg:off(wreg) */
#define  MT16	0x500		/* seg:off(wreg,wreg) */
#define  MIMD	0x600		/* # expr */
#define  MREG	0x700		/* reg */
#define  MREGT	0x800		/* special 386 registers */
#define  MREGD	0x900
#define	 MREGC	0xa00
#define	 MREGS	0xb00		/* seg registers */
#define	 MREL	0xc00		/* PC relative address */
#define	 MREGF	0xd00		/* seg registers */
#define  RMODE	0xf00
#define RVALUE 07

/* Address mode masks */
#define  VABS 	0000001		/* expr */
#define  VIND	0000002		/* seg:off(lreg) */
#define  VTWO	0000004		/* seg:off(lreg,lreg[,s]) */
#define  VINX	0000010		/* seg:off(,lreg[,s]) */
#define  VI16	0000020		/* seg:off(wreg) */
#define  VT16	0000040		/* seg:off(wreg,wreg) */
#define  VIMD	0000100		/* # expr */
#define  VREG	0000200		/* reg */
#define  VREGT	0000400		/* special 386 registers */
#define  VREGD	0001000
#define	 VREGC	0002000
#define	 VREGS	0004000		/* seg registers */
#define	 VREGF	0010000		/* float registers */

#define  VADR	VREG|VIND|VTWO|VINX|VABS
#define  VA16	VREG|VABS|VI16|VT16
#define  VMOD	VREG|VIND|VTWO|VINX|VABS|VI16|VT16
#define  VMEM	VIND|VTWO|VINX|VABS|VI16|VT16

/* Opcode types */
#define TRIGHT	0x0200
#define TLEFT	0x0100
#define TBOTH	0x0300
#define TVAR	0x0500
#define	TZERO1	(60)
#define	TZERO2	(61)
#define	TOPR	(62|TBOTH)
#define	TWORD	(63|TBOTH)
#define	TTWO	(64|TBOTH)
#define	TBIT	(65|TBOTH)
#define	TCALL	(66|TLEFT)
#define	TSTR	(67)
#define	TZERO	(68)
#define	TONE	(69|TLEFT)
#define	TDIV	(70)
#define	TENT	(71|TBOTH)
#define	TIO	(72|TBOTH)
#define	TINT	(73|TLEFT)
#define	TBRA	(74|TLEFT)
#define	TCALLR	(75)
#define	TLGDT	(76|TLEFT)
#define	TPRE	(77)
#define	TMOV	(78|TBOTH)
#define	TEXT	(79|TBOTH)
#define	TPOP	(80|TLEFT)
#define	TDEC	(81|TLEFT)
#define	TSHF	(82|TBOTH)
#define	TRET	(83)
#define	TSET	(84|TLEFT)
#define	TTEST	(85|TBOTH)
#define	TXCHG	(86|TBOTH)
#define TSBRA	(87|TLEFT)
#define TMODE	(88|TLEFT)
#define TFLT1	(89)
#define TFLT2	(90|TLEFT)
#define TFLT3	(91|TLEFT)

/* User defined tokens */
#define	WREG	30
#define	LREG	31
#define	BREG	32
#define	SREG	33
#define	CREG	34
#define	DREG	35
#define	TREG	36
#define FREG	37
#define XREG	38	/* Special reg to handle st(n) */


