/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"
#define	MAXFILES	20

FILE *txtrel, *datrel, *wrkfil, *input, *output;

char line[1024];
int position;
char stitle[72];
char prline[133];
int  prlflag;
char title[72];
FILE *listfil;
char timestamp[25];
char monthname[] = "JanFebMarAprMayJunJulAugSepOctNovDec";

struct tm *timev;

int page, pgline, prflag, prcol;

int ecount, pass, errcnt, linnum, maxerr, startime, stor;
int rflag=0, jflag=0, lflag=0, uflag=1, vflag=0;

unsigned long int loc[N_TYPE], txtloc, datloc, location, txsize;
int section;
unsigned long entry;

#define TMPSTR "/tmp/as"
#define TMPTAIL "XXXXXXX"
char txtfile[sizeof(TMPSTR)+8];
char datfile[sizeof(TMPSTR)+8];
char wrkfile[sizeof(TMPSTR)+8];

char *infil = NULL;
char *outfil  = "a.out";
char *list = NULL;
char *name;
char *inputs[MAXFILES];
int nfiles;
char hex[] = "0123456789ABCDEF";

#define hexit(x)	(hex[(int) x & 017])
#define closefile(x)	if(x != (FILE *)NULL)	{ fclose(x); x = (FILE *)NULL;}


void main(argc,argv) int argc; char *argv[];
{ register int i, x;
  register char *p;

	maxerr = 20;
	name = *argv++;
	nfiles=0;
	while(--argc>0) {
		if(*argv[0] == '-') {
			switch((*argv)[1]) {
			case 'o':
				argc--;
				outfil = *++argv;
				argv++;
				break;
			case 'e':
				argc--;
				maxerr = atoi(*++argv);
				argv++;
				break;
			case 'l':
				argc--;
				list = *++argv;
				argv++;
				break;
			case 'u':
				uflag = 0;
				argv++;
				argc--;
				break;
			case 'L':
				lflag = 1;
				argv++;
				argc--;
				break;
			case 'R':
				rflag = 1;
				argv++;
				argc--;
				break;
			case 'j':
				jflag = 1;
				argv++;
				argc--;
				break;
			case 'v':
				vflag = 1;
				argv++;
				argc--;
				break;
			default:
				fatal("invalid option",*argv);
				/* NOREACHED */
			}
		} else {
			inputs[nfiles++] = *argv++;
			if(nfiles>MAXFILES) fatal("to many input files", (char *)NULL);
			}
		}
	inputs[nfiles] = (FILE *)NULL;
	if(nfiles != 0) {
		nfiles = 0;
		if(opennext()==0) {
			fatal("no input files",(char *)NULL);
			}
		}
	else {
		nfiles = 0;
		input = stdin;
		}
	if(list != (char *)NULL && (listfil = fopen(list,"w")) == 
			(FILE *)NULL) {
		fatal("unable to write list file",list);
		}
	strcpy(wrkfile,TMPSTR);
	strcat(wrkfile, "w");
	strcat(wrkfile, TMPTAIL);
	mktemp(wrkfile);
	if((wrkfil = fopen(wrkfile,"w"))==(FILE *)NULL) {
		fatal("unable to open work file",(char *) NULL);
		}
	pass = 1;
	prolog();
	position = 0;
	line[0] = line[1] = 0;
#ifdef FLEXNAME
	ecount = 1;
#endif
#ifdef MACASM
	maclvl = 0;
	macnest = 0;
	sysindx = 0;
#endif
#ifdef MAXCOND
	currlvl = 0;
#endif
	location = loc[N_TEXT] = loc[N_DATA] = loc[N_BSS] = 0L;
	section = N_TEXT;
	linnum = 0;
	endflag = 1;
	parse();
	pgline = 0;
	page = 1;
	prflag = 7;
	prcol = 0;
	position = 0;
	line[0] = line[1] = 0;
	ecount = 1;
#ifdef MACASM
	maclvl = 0;
	macnest = 0;
	sysindx = 0;
#endif
#ifdef MAXCOND
	currlvl = 0;
#endif
	txsize = loc[N_TEXT];
	loc[N_DATA] = loc[N_TEXT];		/* Fix for dump linkers */
	location = loc[N_TEXT] = loc[N_BSS] = 0L;
	txtloc = datloc = 0L;
	section = N_TEXT;
	linnum = 0;
	endflag = 1;
	closefile(wrkfil);
	strcpy(txtfile,TMPSTR);
	strcat(txtfile, "t");
	strcat(txtfile, TMPTAIL);
	mktemp(txtfile);
	if((txtrel = fopen(txtfile,"w"))==(FILE *)NULL) {
		fatal("unable to open text file",(char *) NULL);
		}
	strcpy(datfile,TMPSTR);
	strcat(datfile, "d");
	strcat(datfile, TMPTAIL);
	mktemp(datfile);
	if((datrel = fopen(datfile,"w"))==(FILE *)NULL) {
		fatal("unable to open data file",(char *) NULL);
		}
	if(outfil != (char *)NULL && (output = fopen(outfil,"w"))
		 == (FILE *)NULL) {
		fatal("unable to write output file",outfil);
		}
	parse();
	if(errcnt == 0) {
		fseek(output,0L,0);
#ifdef MINIX_OBJ
		putc(A_MAGIC0,output);		/* magic number */
		putc(A_MAGIC1,output);
		putc(A_EXEC,output);		/* flags, see below */
		putc(CPU_TYPE,output);		/* cpu id */
		putc(A_MINHDR+16,output);		/* length of header */
		putc(0,output);			/* reserved for future use */
		putwd(0,output);			/* version stamp */
		putl(loc[N_TEXT],output);		/* size of text */
		putl((rflag)?0:
		    loc[N_DATA]-loc[N_TEXT],output);	/* size of data */
		putl(loc[N_BSS],output);		/* size of bss */
		putl(entry,output);			/* entry */
		putl(65365L - (loc[N_BSS] -
			(rflag)?0L: loc[N_DATA]),output);/* total memory */
		putl(symsize*(long)(sizeof(struct nlist))
#ifdef FLEXNAMES
			+ csindex
#endif
				,output);		/* size of symbol */
		putl(txtloc,output);
		putl(datloc,output);			/* relocation */
		putl(0L,output);
		putl(0L,output);
		fseek(output,(long)(A_MINHDR+16+loc[N_DATA]),0);
#else
		putwd(0407,output);			/* magic word */
		putwd(CPU_TYPE,output);			/* cpu type */
		putl(loc[N_TEXT],output);		/* size of text */
		putl((rflag)?0L:loc[N_DATA]-loc[N_TEXT]
						,output); /* size of data */
		putl(loc[N_BSS],output);		/* size of bss */
		putl(symsize*(long)(sizeof(struct nlist))
				,output);		/* size of symbol */
		putl(entry,output);			/* entry */
		putl(txtloc,output);			/* unused */
		putl(datloc,output);			/* relocation */
#ifdef MINIXOBJ
		putl(0, output);			/* stack size */
#endif
		fseek(output,(long)((sizeof(struct exec))+loc[N_DATA]),0);
#endif
		closefile(txtrel);
		if((txtrel = fopen(txtfile,"r"))==(FILE *)NULL) {
			fatal("unable to reopen text file",(char *) NULL);
			}
		closefile(datrel);
		if((datrel = fopen(datfile,"r"))==(FILE *)NULL) {
			fatal("unable to reopen data file",(char *) NULL);
			}
		copyfile(txtrel,output,txtloc);
		copyfile(datrel,output,datloc);
		dosym();
	}
	closefile(txtrel);
	closefile(datrel);
	unlink(txtfile);
	unlink(datfile);
	unlink(wrkfile);
	closefile(output);
	closefile(input);
	epilog(); 
	closefile(listfil);
	}

void errexit()
{
	closefile(wrkfil);
	closefile(txtrel);
	closefile(datrel);
	unlink(txtfile);
	unlink(datfile);
	unlink(wrkfile);
	closefile(listfil);
	closefile(output);
	closefile(input);
	exit(1);
}

void endpass() 
{	int i;
	loc[section] = location;
	if(errcnt>0 && list == (char *)NULL) errexit();
	if(pass==1)
		fixops();
	if((i = (int)(loc[N_TEXT]&3)) != 0) {
		location = loc[N_TEXT];
		section = N_TEXT;
		if(i&1) genword(0L, P_ABS, 1,0);
		if(i&2) genword(0L, P_ABS, 2,0);
		loc[N_TEXT] = location;
		}
	if((i = (int)(loc[N_DATA]&3)) != 0) {
		location = loc[N_DATA];
		section = N_DATA;
		if(i&1) genword(0L, P_ABS, 1,0);
		if(i&2) genword(0L, P_ABS, 2,0);
		loc[N_DATA] = location;
		}
	if((i = (int)(loc[N_BSS]&3)) != 0) {
		location = loc[N_BSS];
		section = N_BSS;
		if(i&1) genword(0L, P_ABS, 1,0);
		if(i&2) genword(0L, P_ABS, 2,0);
		loc[N_BSS] = location;
		}
	pass ++;
	if(pass != 3) {
		closefile(input);
		if((input = fopen(wrkfile,"r")) == (FILE *)NULL) {
			fatal("unable to reopen workfile",(char *) NULL);
			}
		fixsym();
		return;
		}
}

void fillloc(v,s) unsigned long int v; int s;
{ register int i;

	for(i=prcol+s-1; i>=prcol; i--) {
		prline[i] = hexit(v);
		v = v >> 4;
		}
	prcol += s;
}

void set(s,p) char *p,*s;
{ register int i;

	for(i=0; i<71; i++ )
	if(*p!='\0') *s++ = *p++;
	else *s++ = ' ';
	*s++ = '\0';
}

void printit()
{ register int i;

	prcol = 0;
	if(pass==1 || list==(char *)NULL || (prflag&prlflag) != 0 ) return;
	if(pgline==0) {
		putc('\f',listfil);
		prtstr(title,listfil);
		prtstr(" Page ",listfil);
		prtdec((long)page++,listfil);
		putc('\t',listfil);
		prtstr(timestamp,listfil);
		putc('\n',listfil);
		prtstr(stitle,listfil);
		putc('\n',listfil);
		putc('\n',listfil);
		pgline = 3;
		}
	prtstr(prline,listfil);
/*prtstr(prline,stderr); */
	if((pgline++) > LPPG) pgline = 0;
	for(i=0; i<=START; prline[i++] = ' ');
	prline[i++] = '\n';
	prline[i++] = '\0';
	}

void prtstr(s,f) char *s; FILE *f;
{
	while(*s) putc(*s++,f);
}

void prtdec(n,f) long int n; FILE *f;
{ register long a;
	if(n<0) {
		putc('-',f);
		n = -n;
		}
	if(a = n/10) prtdec(a,f);
	putc(hexit(n%10),f);
}

void prolog()
{ register int i;
  long int t;
	/* set up time and date */
	t = time(0);
	timev = localtime(&t);

	timestamp[0] = timev->tm_mday /10 + '0';
	timestamp[1] = timev->tm_mday %10 + '0';
	i = timev->tm_mon * 3;
	timestamp[2] = '-';
	timestamp[3] = monthname[i++];
	timestamp[4] = monthname[i++];
	timestamp[5] = monthname[i++];
	timestamp[6] = '-';
	timestamp[7] = timev->tm_year /10 + '0';
	timestamp[8] = timev->tm_year %10 + '0';
	timestamp[9] = ' ';
	timestamp[10] = timev->tm_hour /10 + '0';
	timestamp[11] = timev->tm_hour %10 + '0';
	timestamp[12] = ':';
	timestamp[13] = timev->tm_min  /10 + '0';
	timestamp[14] = timev->tm_min  %10 + '0';
	timestamp[15] = ':';
	timestamp[16] = timev->tm_sec  /10 + '0';
	timestamp[17] = timev->tm_sec  %10 + '0';
	timestamp[18] = '\0';

	/* set up the start time */
	startime = timev->tm_sec + 60 * timev->tm_min + 3600 * timev->tm_hour;

	/* clear storage used count */
	stor = 0L;
	errcnt = 0;
	pass = 1;
	entry = 0;
	initsym();
	set(title,DTITLE);
	set(stitle," ");
#ifdef MACASM
	mactab = NULL;
	global = NULL;
#endif
	}

void epilog() {
	register int endtime, h,m,s;
	long int t;

	/* print symbol table */
	printsym();
	/* compute runtime */
	t = time(0);
	timev = localtime(&t);
	endtime = timev->tm_sec + 60 * timev->tm_min + 3600 * timev->tm_hour;
	endtime = endtime - startime;
	s = endtime % 60;
	m = ((endtime - s) % 3600) / 60;
	h = (endtime - (60*m + s)) / 3600;
	if(vflag) {
		prtdec(loc[N_TEXT],stderr);
		prtstr("(text) + ",stderr);
		prtdec(loc[N_DATA]-loc[N_TEXT],stderr);
		prtstr("(data) + ",stderr);
		prtdec(loc[N_BSS],stderr);
		prtstr("(bss) = ",stderr);
		prtdec(loc[N_TEXT]+loc[N_DATA]-loc[N_TEXT]+loc[N_BSS],stderr);
		prtstr("\n core used = ",stderr);
		prtdec((long)stor,stderr);
		prtstr(" bytes ",stderr);
		strcpy(prline,"run time  00:00:00  ");
		prline[10] = h/10 + '0';
		prline[11] = h%10 + '0';
		prline[13] = m/10 + '0';
		prline[14] = m%10 + '0';
		prline[16] = s/10 + '0';
		prline[17] = s%10 + '0';
		prtstr(prline,stderr);
		prtstr("lines per minute ",stderr);
		if(endtime==0) 	prtdec(0L,stderr);
		else 		prtdec((long)((linnum*60)/endtime),stderr);
		putc('\n',stderr);
	}
	if(list == (char *)NULL) return;
	printit();
	if(pgline >= (LPPG - 11)) pgline = 0;
	printit();
	strcpy(prline,"entry =         \n");
	prcol = 8;
	fillloc(entry,ADDRSZ);
	printit();
	prtdec(loc[N_TEXT],listfil);
	prtstr("(text) + ",listfil);
	prtdec(loc[N_DATA]-loc[N_TEXT],listfil);
	prtstr("(data) + ",listfil);
	prtdec(loc[N_BSS],listfil);
	prtstr("(bss) = ",listfil);
	prtdec(loc[N_TEXT]+loc[N_DATA]-loc[N_TEXT]+loc[N_BSS],listfil);
	prtstr("\n\n core used = ",listfil);
	prtdec((long)stor,listfil);
	prtstr(" bytes\n",listfil);
	strcpy(prline,"run time  00:00:00\n");
	prline[10] = h/10 + '0';
	prline[11] = h%10 + '0';
	prline[13] = m/10 + '0';
	prline[14] = m%10 + '0';
	prline[16] = s/10 + '0';
	prline[17] = s%10 + '0';
	printit();
	/* compute lines per minute */
	prtstr("lines per minute ",listfil);
	if(endtime==0) 	prtdec(0L,listfil);
	else 		prtdec((long)((linnum*60)/endtime),listfil);
	putc('\n',listfil);
	switch(errcnt) {
	case 0:		prtstr("no errors detected",listfil);
			break;
	case 1:		prtstr("1 error detected",listfil);
			break;
	default:	prtdec((long)errcnt,listfil);
			prtstr(" errors detected",listfil);
			break;
	}
	putc('\n',listfil);
}

/* Open next input file */
int opennext() {
	if(pass==2) return(0);
	closefile(input);
	if((nfiles > MAXFILES) || (inputs[nfiles] == (char *)NULL)) {
		input = (FILE *)NULL;
		return(0);
		}
	if((input = fopen(inputs[nfiles++],"r")) == (FILE *)NULL) {
		fatal("unable to open input",inputs[nfiles-1]);
		}
	return(1);
	}

void readline()
{ register int i,f;
  register char c;
  static char *endstr = "\n	.end\n";

	position = 0;
	i = 0;
	f = 0;
	while(endflag) {
		c=getc(input);
		if(c == '"' || c == '\'') {
			if(f) {
				if(pass==1) putc(c,wrkfil);
				line[i++] = c;
				c=getc(input);		/* double or end */
				if(c != '"' && c != '\'') f = 0;
				}
			else	f = 1;	/* first one */
			}
		if(c== EOF) {
			register char *p;

			endflag = opennext();
			if(endflag == 0) 
				for(p=endstr; *p ; p++) line[i++] = *p;
			continue;
			}
		if(pass==1) putc(c,wrkfil);
		line[i++] = c;
		if(c=='\n' || (f == 0 && c==LINSEP)) break;
		}
	if(c!=LINSEP) linnum++;
#ifdef MACASM
	if(pass == 1) putc(maclvl,wrkfil);
	if(pass == 2) {	 c = getc(input);
			 if(c== EOF) {	register char *p;
					opennext();
					for(p=endstr; *p ; p++) line[i++] = *p;
					c = 0;
					}
			 maclvl = c;
			}
#endif
#ifdef MAXCOND
	if(pass == 1) putc(condval[currlvl],wrkfil);
	if(pass == 2) {	 c = getc(input);
			 if(c== EOF) {	register char *p;
					opennext();
					for(p=endstr; *p ; p++) line[i++] = *p;
					c = 0;
					}
			 condval[0] = c;
			}
#endif
	line[i-1] = '\n';
	line[i++] = '\0';
	for(i=0; i <= START; prline[i++] = ' ');
	for(i=0; line[i] != '\0' && (i+START) < 132; i++)
		prline[START+i]= line[i];
	prline[START+i++] = '\0';
	prlflag = 010;
	return;
}

void error(c) int c;
{ 

	prline[0] = c;
	putc(c,stderr);
	prtstr(" at line ",stderr);
	prtdec((long)linnum,stderr);
	putc('\n',stderr);
	if(maxerr <= errcnt++) errexit();
}

void  fatal(s,p) char *s, *p;
{
	prtstr(name,stderr);
	prtstr(": ",stderr);
	prtstr(s,stderr);
	putc(' ',stderr);
	if(p != (char *) NULL) prtstr(p,stderr);
	putc('\n',stderr);
	errexit();
}

void putl(i, iop)
register unsigned long i;
register FILE *iop;
{
#ifdef LITTLE
	putwd((int)i, iop);
	putwd((int)(i>>16), iop);
#else
	putwd((int)(i>>16), iop);
	putwd((int)i, iop);
#endif
}

int putwd(i, iop)
unsigned int i;
register FILE *iop;
{
#ifdef LITTLE
	putc(i, iop);
	putc(i>>8, iop);
#else
	putc(i>>8, iop);
	putc(i, iop);
#endif
}


void copyfile(in,out,size)	register FILE *in, *out; register long int  size;
{  char c;
	for(; size>0 ; size--) {
		c=getc(in);
		putc(c,out);
		}
}
