
/***************************************************
 *                                                 *
 *    macro Assembler			           *
 *                                                 *
 *    Copyright 1989    Richard P. Cornwell        *
 *    Developmental Code not for redistubution     *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"


char *labfld;
char *opcfld;
char *oprand;
int pos, size;
int endflag;

#ifdef MAXCOND
int condval[MAXCOND];
int currlvl;
#define CTRUE	1
#define CFALSE	0
#define CSKIP	2
#define CPASS	4
#endif


/* Scan a line and break it up into fields */
void
scan()
{ 
	register int i;
	register char c, *word;

	labfld = NULL;
	opcfld = NULL;
	oprand = NULL;
	while(opcfld == 0) {
		i=0;
		while((c=line[position++])==' ' || c=='\t' );
		if(c==COMMENT || c=='\n' || c=='\0') break;
		while(c!='\n' && c!=' ' && c!='\t' && c!=COMMENT && c!='\0') {
#ifdef FLEXNAMES
			i++;
#else
			if(i<NCPS*2) word[i++] = c;
#endif
			c=line[position++];
			}
		word = &line[position-i-1];
		word[i] = '\0';
		if(i>1 && word[i-1] == ':') {
			if(labfld)
			   { error('X');
			     return;
			     }
			else
			   { word[i-1] = '\0';
			     labfld = word;
			     }
			}
		else if(word[0] != 0) {
			opcfld = word;
			}
	  }
	i=0;
	c=line[position++];
	while( c!='\0' && c!='\n' && c!=COMMENT) {
		i++;
		if(c=='\'' || c=='"') {
			register char cend;
			cend = c;
			do {
				c=line[position++];
				i++;
				if(c==cend && line[position] == cend) {
					i++; position++;
					continue;
					}
		  		} while(c!=cend);
			}
		c=line[position++];
		}
	oprand = &line[position-i-1];
	oprand[i] = '\0';
	}


/* Parse a line and generate to approprate code */
parse() {
	register struct opcodes *ptr;
#ifdef MACASM
	register struct mac *m;
#endif

while(endflag) {
#ifdef MAXCOND
	while(1) {
#endif
#ifdef MACASM
		getline();
#else
		readline();
#endif
		scan();
#ifdef MAXCOND
		if(pass==2) {
			if((condval[0]&CSKIP)==0) break;
			prlflag |= 4;
			printit();
			}
		else {
			if(currlvl==0 || (condval[currlvl]&CSKIP)==0) break;
			if(opcfld && (ptr=oplook(opcfld)) != NULL &&
					ptr->type >= ENDC && ptr->type <= IFU)
						break;
			}
	}
#endif
	if((opcfld)==0) {
		 if(labfld) enter(labfld,location,section);
		 printit();
		 continue;
		 }
	if((ptr=oplook(opcfld)) != NULL) {
		if((ptr->type&0xfff) <= MAXSYS) psuedo(ptr);
		else			machine(ptr);
		continue;
		}
#ifdef MACASM
	if((m=macfind(opcfld))!=NULL) {
		printit();
		macbuild(m);
		continue;
		}
#endif
	error('U');
	printf("Error in %s\n", opcfld);
	printit();
   	}
endpass();
}


psuedo(ptr)	struct opcodes *ptr;
{
	char word[NCPS*2],c;
	register int i, sz;
	unsigned int base;
	unsigned int mode;
	struct ex right, left;
#ifdef MACASM
	struct mac *m;
#endif

	pos = 0;
	sz = size;
	switch(ptr->type&0xfff) {
	case	CSECT:
		loc[section] = location;
		section = N_TEXT;
		location = loc[section];
		if(labfld) enter(labfld,location,section);
		printit();
		break;
	case	DSECT:
		loc[section] = location;
		section = N_DATA;
		location = loc[section];
		if(labfld) enter(labfld,location,section);
		printit();
		break;
	case	BSS:
		loc[section] = location;
		section = N_BSS;
		location = loc[section];
		if(labfld) enter(labfld,location,section);
		printit();
		break;
	case	BLOCK:
		pos = 0;
		prcol = 1;
		if(labfld) enter(labfld,location,section);
		if(expr(&left)>0 && (left.sym->flag&N_TYPE) == N_ABS) {
			fillloc(location,ADDRSZ);
			prcol+=2;
#ifdef MC68000
			if(sz == 0)	sz = 2;
			left.val *= sz;
#endif
			fillloc(left.val,ADDRSZ);
			printit();
			if(section == N_BSS) location += left.val;
			else {
				i = prflag;
				prflag |= 010;
				for(pos=1; pos <=left.val; pos++) {
					genword(0L,P_ABS,1, 0);
					}
				prflag = i;
				}
			}
		else error('R');
		break;
	case	LONG:
		if(labfld) enter(labfld,location,section);
		pos = 0;
		while(expr(&left)>0) {
			genword(left.val,left.sym,4,0);
			}
		printit();
		break;
	case	WORD:
		if(labfld) enter(labfld,location,section);
		pos = 0;
		while(expr(&left)>0) {
			genword(left.val,left.sym,2,0);
			}
		printit();
		break;
	case	EVEN:
		if(labfld) enter(labfld,location,section);
		if(ptr->base) {
			pos = 0;
			if(expr(&left)>0 && (left.sym->flag&N_TYPE) == N_ABS) 
				sz=left.val-1;
			else error('R');
		} else sz=1;
		if(pass == 1) {
			for(i=0; (location+i)&sz; i++);
			addchain(location, NULL, XALIGN|section, i, sz);
		}
		while(location&sz) genword(0L,P_ABS,1,0);
		printit();
		break;
	case	BYTE:
		if(labfld) enter(labfld,location,section);
		while(expr(&left)>0) {
			if((left.sym->flag&N_TYPE) != N_UNDF 
				&& (left.sym->flag&N_TYPE) != N_ABS) {
				error('R');
				left.val = 0L;
				}
			genword(left.val,P_ABS,1,0);
			}
		printit();
		break;
	case	END:
	 	if(labfld) enter(labfld,location,section);
		printit();
		endflag = 0;
		break;
	case	ENTRY:
		if(labfld == NULL) { error('X'); break; }
		if(labfld[0] != '$') {
			enter(labfld,location,N_TEXT);
			entry = location;
			printit();
			}
		else error('L');
		break;
	case	GLOBAL:
	case	EXTERN:
		pos=0; i=0; 
		while(expr(&left)>0) {
			if(left.sym->name[0] == '$') error('G');
			else		left.sym->flag |= N_EXT;
			}
		printit();
		break;
	case	COMM:
		pos = 0;
		if(expr(&left)>0) {
			expr(&right);
			if(right.sym->flag != N_ABS) error('R');
			if(pass != 2) {
				left.sym->flag = N_UNDF|N_EXT;
				left.sym->value = right.val;
			}
			prcol = 10;
			fillloc(right.val,ADDRSZ);
			printit();
			}
		else	error('X');
		break;
	case	LCOMM:
		pos = 0;
		if(expr(&left)>0) {
			expr(&right);
			if(right.sym->flag != N_ABS) error('R');
			if(section == N_BSS) {
				left.sym->value = location;
				location += right.val;
			} else {
				left.sym->value = loc[N_BSS];
				loc[N_BSS] += right.val;
			}
			left.sym->flag = N_BSS;
			prcol = 10;
			fillloc(right.val,ADDRSZ);
			printit();
			}
		else	error('X');
		break;
	case	SET:
		pos = 0;
		if(expr(&left)>0) {
			expr(&right);
			if((right.sym->flag&N_ETYP) == N_UNDF) error('U');
			prcol = 10;
			fillloc(right.val,ADDRSZ);
			if((right.sym->flag&N_TYPE) != N_ABS) prline[9] = '`';
			if(pass != 2) {
				left.sym->flag &= ~N_EXT;
				left.sym->value = right.val;
			}
			printit();
			}
		else	error('X');
		break;
	case	EQU:
	 	pos = 0;
		if(expr(&left)>=0) {
			if((left.sym->flag&N_ETYP) == N_UNDF) error('U');
			prcol = 10;
			fillloc(left.val,ADDRSZ);
			if((left.sym->flag&N_TYPE) != N_ABS) prline[9] = '`';
			if(labfld) {
				if(ptr->type==SET) lookup(labfld,NODEF);
				enter(labfld,left.val,left.sym->flag);
				}
			else error('L');
			printit();
			}
		else error('X');
		break;
	case	ASCII:
	case	ASCIZ:
		if(labfld) enter(labfld,location,section);
		i = unquote(oprand);
		for(pos = 0; pos < i; pos++) {
			genword((long)oprand[pos],P_ABS,1,0);
			}
		if(ptr->type == ASCIZ) genword(0L,P_ABS,1,0);
		printit();
		break;
	case	STABS:
		/*	find start of string */
		for(pos = 0; oprand[pos] != '"' && oprand[pos] != '\0'
			&&   oprand[pos] != '\n' ; pos++);
		if(oprand[pos+1] == '\0') { error('X'); break; }
		/*	scan over until end */
		for(pos++; oprand[pos] != '\0' && oprand[pos] != '\n';
			 pos++) {
				if(oprand[pos] == '"' &&
					oprand[pos+1] != '"') break;
				if(oprand[pos] == '"') pos ++;
				}
		/* lastly skip until ',' found */
		for(; oprand[pos] != '\0' && oprand[pos] != '\n'
			&& oprand[pos] != ','; pos++);
		pos++;	/* move after it */
		/* now make the string */
		unquote(oprand);
	case 	STABN:
	case	STABD:
		if(pass == 1) break;
		if(expr(&left)!= 2) {error('T');  printit(); break; }
		if((left.sym->flag&N_TYPE) != N_ABS) {
				error('R');
				left.val = 0L;
				}
		base = (int)left.val;
		if(expr(&left)!= 2) {error('1'); printit();  break; }
		if((left.sym->flag&N_TYPE) != N_ABS) {
				error('R');
				left.val = 0L;
				}
		mode = left.val;
		sz=expr(&left);
		if(ptr->type == STABD && sz == 2) error('X');
		if(ptr->type != STABD && sz != 2) error('2');
		if((left.sym->flag&N_TYPE) != N_ABS) {
				error('R');
				left.val = 0L;
				}
		i = left.val;
		if(ptr->type != STABD) expr(&left);
		else		left.val = location;
		makestab((ptr->type==STABS)?oprand:NULL,base,mode,i,left.val);
		printit();
		break;
#ifdef MACASM
	case	MACRO: 
		macadd();
		printit();
		break;
	case	MEND: 
		macend();
		prlflag |= 2;
		printit();
 		break;
	case	MSETL: 
		for(position = 0;oprand[position] != ' ' ||
			oprand[position] != '\t'; position++);
		macset(labfld,&oprand[position]);
		prlflag |= 2;
		printit();
		break;
	case	MSET:
		prlflag |= 2; 
		printit();
		break;
#endif
#ifdef MAXCOND
	case	IF:
		if( pass == 2) {
			prlflag |= 4;
			printit();
			break;
			}
		if(currlvl!=0 && condval[currlvl]&CSKIP) {
			if(currlvl++>MAXCOND) { error('N'); currlvl--;}
			condval[currlvl] = CSKIP|CPASS;
			}
		else {
			if(currlvl++>MAXCOND) { error('N'); currlvl--; }
			pos = 0;
			if(expr(&left)<0) error('X');
			if((left.sym->flag&N_TYPE)!=N_ABS) error('X');
			condval[currlvl]=(left.val==0)?CFALSE|CSKIP:CTRUE;
			}
		break;
	case	IFD:
		if(pass == 2) {
			prlflag |= 4;
			printit();
			break;
			}
		pos=0; i=0; 
		do {
			if(oprand[pos] == ' ' || oprand[pos] == '\t' ||
			   oprand[pos] == ',' || oprand[pos] == '\0') {
				word[i] = '\0';
				if(i != 0) {
					i = defed(word);
					break;
					}
				i=0;
				}
			else word[i++] = oprand[pos];
			} while(oprand[pos++] != '\0');
		if(currlvl++>MAXCOND) { error('N'); currlvl--; }
		condval[currlvl] = (i==0)?CFALSE|CSKIP: CTRUE;
		break;
	case	IFU:
		if(pass == 2) {
			prlflag |= 4;
			printit();
			break;
			}
		pos=0; i=0; 
		do {
			if(oprand[pos] == ' ' || oprand[pos] == '\t' ||
			   oprand[pos] == ',' || oprand[pos] == '\0') {
				word[i] = '\0';
				if(i != 0) {
					i = defed(word);
					break;
					}
				i=0;
				}
			else word[i++] = oprand[pos];
			} while(oprand[pos++] != '\0');
		if(currlvl++>MAXCOND) { error('N'); currlvl--; }
		condval[currlvl] = (i==0)?CFALSE: CTRUE|CSKIP;
		break;
	case	ENDC:
		if(pass==2) {
			prlflag |= 4;
			printit();
			break;
			}
		if(currlvl==0) error('N');
		else currlvl--;
		break;
	case	IFT:
		if(pass==2) {
			prlflag |= 4;
			printit();
			break;
			}
		if(currlvl==0) error('X');
		else if((condval[currlvl]&CPASS)==0) {
			if(condval[currlvl]&CTRUE)
				condval[currlvl] &= ~CSKIP;
			else
				condval[currlvl] |= CSKIP;
			}
		break;
	case	IFF:
		if(pass==2) {
			prlflag |= 4;
			printit();
			break;
			}
		if(currlvl==0) error('X');
		else if((condval[currlvl]&CPASS) == 0) {
			if(condval[currlvl]&CTRUE)
				condval[currlvl] |= CSKIP;
			else
				condval[currlvl] &= ~CSKIP;
			}
		break;
	case	IFTF:
		if(pass==2) {
			prlflag |= 4;
			printit();
			break;
			}
		if(currlvl==0) error('X');
		else if((condval[currlvl]&CPASS)==0) 
			condval[currlvl] &= ~CSKIP;
		break;
#endif
	case	TITLE:
		i = unquote(oprand);
		set(title,oprand);
		break;
	case	SPACE:
		if(expr(&left) == 0)	printit();
		else {
			for(i=(int)left.val; i>0; i--) printit();
			}
		break;
	case	PAGE:
		pgline = 0;
		break;
	case	STITLE:
		i = unquote(oprand);
		set(stitle,oprand);
		break;
	case	PRINT:
		pos = 0; i = 0;
		do {
			if(oprand[pos] == ' ' || oprand[pos] == '\t' ||
		 	   oprand[pos] == ',' || oprand[pos] == '\0') {
				word[i] = '\0';
				if(i != 0) {
				if(strcmp(word,"on") == 0) prflag &= ~010;
				else if(strcmp(word,"off") == 0) prflag |= 010;
#ifdef MACASM
				else if(strcmp(word,"nogen") == 0) prflag |= 1;
				else if(strcmp(word,"gen") == 0) prflag &= ~1;
				else if(strcmp(word,"nologic")==0) prflag |= 2;
				else if(strcmp(word,"logic") == 0) prflag &= ~2;
#endif
#ifdef MAXCOND
				else if(strcmp(word,"cond") == 0) prflag |= 4;
				else if(strcmp(word,"nocond")==0) prflag &= ~4;
#endif
				else error('U');
				}
				i=0;
				}
	 		else word[i++] = oprand[pos];
			} while(oprand[pos++] != '\0');
		break;
		}
}


/* Remove quotes from around a string, doing '\' substitution */
/* return lenght */
int unquote(s) char *s;
{ register int i,j;

  for(i=0, j=0; s[i]!='"' && s[i] != '\0' && s[i] != '\n'; i++);
  if(s[i++] != '\0')
	for(;s[i] != '"' && s[i] != '\0' && s[i] != '\n'; i++) {
		if(s[i] == '\\') {
  			register char c;
			/* Handle escapes */
			i++; /* skip slash */
			switch(s[i]) {
				case '\\': c = '\\'; break;
				case '"':  c = '"'; break;
				case 'n':  c = '\n'; break;
				case 'r':  c = '\r'; break;
				case 't':  c = '\t'; break;
				case 'b':  c = '\b'; break;
				case 'f':  c = '\012'; break;
				case 'e':  c = '\033'; break;
				case ' ':  c = ' '; break;
				case '0': case '1': case '2': case '3':
				case '4': case '5': case '6': case '7':
				  	   c = s[i] - '0';
				  	   while(s[i+1] >= '0'&&s[i+1] <= '7') 
						c = (c<<3) + (s[++i] - '0');
				  	   break;
				default:	
				  	   error('e');
				}
			s[j++] = c;
			}
		else s[j++] = s[i];
		if(s[i+1] == '"' && s[i+2] == '"')
			{ s[j++] = s[++i]; i++; }
		}
  s[j] = '\0';
  return(j);
  }


struct opcodes *oplook(str) char *str;
{   register int s,e,m,t,z;
    char *p;
    	
#ifdef SCANOPC
	opscan(opcfld);
#endif
	s=0; e=opsize; t=2; m=s; z=e;
	while(m!=z) {
		z = m;
		m = (s+e)>>1;
		t = strcmp(str,optab[m].opc);
		if(t==0) {
#ifdef MITASM
			size = ((optab[m].type)>>12)&0xf;
#endif
			return(&optab[m]);
			}
		else if(t<0)	e = m;
		else if(t>0)	s = m;
		}
	return(NULL);
}


char relcode(m) int m;
{    switch(m) {
	case N_EXT|N_UNDF:	return('E');
	case N_ABS:		return(' ');
	case N_TEXT:		return('`');
	case N_DATA:		return('^');
	case N_BSS:		return('\'');
	case N_EXT|N_ABS:
	case N_EXT|N_TEXT:
	case N_EXT|N_DATA:
	case N_EXT|N_BSS:
				return('G');
	default:		return('?');
	}
}

void
genword(x,p,sz,pcrel) unsigned long x; int sz,pcrel; struct symbol *p;
{
static int lastsect = -1;
long		r_vaddr;	/* virtual address of reference */
long		r_symndx;	/* internal segnum or extern symbol num */
unsigned short	r_type;		/* relocation type */

/* fprintf(stderr,"genword(%lx, %o, %d, %d);\n",x,p,sz,pcrel); */
	if(sz>1 && location&ALIGN ) error('O');
	if(pass == 1) {
		location+=sz;
		return;
		}
	if(p->flag == N_UNDF) error('U');
	if(section == N_BSS) {
		if(x!=0) error('D');
		goto bss;
		}
	if(section != lastsect) {
		if(section== N_TEXT || rflag) 
			fseek(output,(long)(sizeof(struct exec))+location,0);
		else
			fseek(output,(long)(sizeof(struct exec))+location,0);
		lastsect = section;
		}
	switch(sz) {
	case 4:		putl(x,output); break;
	case 2:		putwd((int)x,output); break;
	case 1:		putc((char)x,output); break;
	}
#ifdef MINIX_OBJ
	r_vaddr = location;
	r_symndx = 0;
	if((p->flag&N_TYPE) != N_ABS) {
		if(p->flag==(N_UNDF|N_EXT)) r_symndx = p->index;
		else   {
			switch(p->flag & N_TYPE) {
			case N_ABS:	r_symndx = S_ABS; break;
			case N_TEXT:	r_symndx = S_TEXT; break;
			case N_DATA:	r_symndx = 
				(rflag)?S_TEXT:S_DATA; break;
			case N_BSS:	r_symndx = S_BSS; break;
			default:	error('R');
			}
		}
		switch(sz) {
		case 1:	r_type = (pcrel)?R_PCRBYTE:R_RELLBYTE; break;
		case 2: r_type = (pcrel)?R_PCRWORD:R_RELWORD; break;
		case 4: r_type = (pcrel)?R_PCRLONG:R_RELLONG; break;
		}
		if(section==N_TEXT) {
			txtloc += 8;
			putl(r_vaddr,txtrel);
			putwd((int)r_symndx,txtrel);
			putwd((int)r_type,txtrel);
		} else {
			datloc += 8;
			r_vaddr -= txsize;
			putl(r_vaddr,datrel);
			putwd((int)r_symndx,datrel);
			putwd((int)r_type,datrel);
			}
		}
#else
#ifdef FLEXNAMES
	r_vaddr = location;
	r_symndx = 0;
	    /*  pad  extern       length        pcrel */
	r_type = 0 |   0    | ((3&(sz>>1))<<1) | (pcrel&01);
	if((p->flag&N_TYPE) != N_ABS) {
		if(p->flag==(N_UNDF|N_EXT)) {
			r_type |= 0x10;
			r_symndx = p->index;
			}
		else   {
			r_symndx = p->flag & N_TYPE; 
			if(rflag && r_symndx == N_DATA)
				r_symndx = N_TEXT;
			}
		r_symndx &= 0x00ffffff;
		r_symndx |= r_type<<24;
		if(r_type & 0x10) {
			if(section==N_TEXT) {
				txtloc += 8;
				putl(r_vaddr, txtrel);
				putl(r_symndx, txtrel);
			} else {
				datloc += 8;
				r_vaddr -= txsize;
				putl(r_vaddr, datrel);
				putl(r_symndx, datrel);
				}
			}
		}
#else
	rel = 0;
	if((p->flag&N_TYPE) != N_ABS) {
		if(p->flag==(N_UNDF|N_EXT)) {
			rel = (p->index<<4) | (p->flag&N_TYPE);
			}
		else   {
			rel = p->flag & N_TYPE; 
			if(rflag && rel == N_DATA)
				rel = N_TEXT;
			}
		if((p->flag&N_TYPE) == N_PCR) rel |= 1;
		if(section==N_TEXT) {
			txtloc += 2;
			putwd(rel, txtrel);
		} else {
			datloc += 2;
			putwd(rel, datrel);
		}
	}
#endif
#endif
bss:
	if((prcol+sz+sz+2)>START) printit();
	if(prcol==0) {	prcol = 1; fillloc(location,ADDRSZ); prcol += 2; }
	fillloc(x,sz+sz);
	prline[prcol++] = relcode(p->flag);
	prline[prcol++] = ' ';
	location+=sz;
}

