/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

#define REGFIELD(x)	((x>>8)&0377)

int byte_flag=3;
extern int grp1fix[], grp2fix[], grp0fix[];

machine(ptr)	struct opcodes *ptr; 
{
	register int i, sz, flag;
	unsigned int base, mode;
	struct ex right;

	base = ptr->base;
	pos = 0;
	sz = 1;
	if(labfld) enter(labfld,location,section);
	right.mode = 0;
	i = ptr->type;
	if(i&RIGHT) {
		if(address(&right,0) != 0) error('X');
		}
	switch(i) {
	case TBRL:
		sz = 2;
	case TBRS:
		if(right.mode == MABS)
			right.val =  right.val-(location+((base&0xff00)?4:2));
		else	error('R');
		if((right.sym->flag&N_TYPE) != section && pass == 2) error('R');
		if(sz == 1) {	/* quick case */
			i = right.val&(~0x7f);
			if(pass == 2) 
				if(!(i!=0 || i!=(~0x7f))) error('B');
			right.val &= 0377;
			right.mode = MDIR;
			}
		right.sym = P_ABS;
		break;
	case TGRP1:
		base += grp1fix[(right.mode&RMODE)-1];
		if(byte_flag&1) sz = 2;
		break;
	case TGRP2:	
		base += grp2fix[(right.mode&RMODE)-1];
		if(byte_flag&2) sz = 2;
		break;
	case TZER:	
		right.mode = MIMP;
		break;
	case TBRK:
		if(right.mode != MABS) error('A');
		if(right.sym != P_ABS && pass == 2) error('M');
		right.sym = P_ABS;
		sz = 1;
		break;
	case TJMP:
		break;
	case TPSH:
		break;
	case TFLG:
		break;
	case TBIT:
		break;
	case TSMODE:
		byte_flag |= base;
		printit();
		return;
	case TRMODE:
		byte_flag &= base;
		printit();
		return;
	}
	genword(base&0xff,P_ABS,1);
	genea(&right,sz);
	printit();
}


/* Eval an addressing mode. */

int address(p,ind)
register struct ex *p;
int ind;
{ register int x, y, z;

	sp = 0;
	oldptr = -1;
	p->val = 0;
	p->sym = P_ABS;
	x = lex();
	switch(x) {
	case RBRACE:
		if((x = lex()) != TIMES) error('[');
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MINL;
		if(x != LBRACE) error(']');
		if((y = lex()) == COMMA) {
			y = lex();
			if(y == NUMBER && (stksym[sp]->flag&N_TYPE) != REG &&
				stksym[sp]->value != REGY) {
				unlex(y);
				unlex(COMMA);
				error('I');
				}
			else p->mode = MDRYL;
		} else  unlex(y);
		break;
	case NUM:
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MIMD;
		break;
	case RPARN:
		if((x = lex()) == TIMES) {
			x = orop();
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MIND;
			if(x == COMMA) {
				x = lex();
				if(x == NUMBER && (stksym[sp]->flag&N_TYPE)
					!= REG) {
					unlex(x);
					unlex(COMMA);
					error('i');
				}
				switch(stksym[sp]->value) {
				case REGY:	error('I'); break;
				case REGX:	p->mode = MINX; break;
				case REGS:	p->mode = MDRS; break;
				}
				x = lex();
			} 
			if(x != LPARN) error(')');
			if((x = lex()) == COMMA) {
				x = lex();
				if(x == NUMBER && (stksym[sp]->flag&N_TYPE)
					!= REG && stksym[sp]->value != REGY) {
					unlex(x);
					unlex(COMMA);
					error('i');
				}
				else if(p->mode == MIND) p->mode = MINY;
				if(p->mode == MINX) error('I');
				x = lex();
			}
		} else	{
			unlex(x);
			x = orop();
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MABI;
			if( x = COMMA) {
				x = lex();
				if(x == NUMBER && (stksym[sp]->flag&N_TYPE)
					!= REG && stksym[sp]->value != REGX) {
					unlex(x);
					unlex(COMMA);
					error('i');
				}
				else p->mode = MILX;
				x = lex();
			}
			if(x != LPARN) error(')');
		}
		break;
	case TIMES:
		x = orop();
		p->val = stkval[0];
		p->sym = stksym[0];
		p->mode = MDIR;
		if(x == COMMA) {
			x = lex();
			if(x == NUMBER && (stksym[sp]->flag&N_TYPE)
				!= REG) {
				unlex(x);
				unlex(COMMA);
				error('i');
			}
			else {
				switch(stksym[sp]->value) {
				case REGX:	p->mode = MDRX; break;
				case REGY:	p->mode = MDRY; break;
				case REGS:	p->mode = MSTK; break;
				}
				x = lex();
			}
		}
		break;
	case NUMBER:
		/* fall thru */
	default:
	l:	unlex(x);
		x = orop();
		switch(x) {
		case EOL:
		case -1:
			p->val = stkval[0];
			p->sym = stksym[0];
			p->mode = MABS;
			break;
		case COMMA:
			x = lex();
			if(x != NUMBER && (stksym[sp]->flag&N_TYPE) != REG)
				error('A');
			z = stksym[sp]->value;
			if(z == REGS) error('i');
			p->val = stkval[sp];
			p->sym = stksym[sp];
			p->mode = (z = REGX)?MABX: MABY;
			x = lex();
			break;
		default: error('A');
		}
	}
	switch(x) {
		case -1: return(0);
		case EOL: return(0);
		case LBRACE: return(2);
		default: return(-1);
		}
	}

swap(a,b)
struct ex *a, *b;
{
	register int i;
	register struct symbol *p;
	
	i=a->val;
	a->val = b->val;
	b->val = i;
	p=a->sym;
	a->sym = b->sym;
	b->sym = p;
	i=a->mode;
	a->mode = b->mode;
	b->mode = i;
	}

int genea(p,sz) struct ex *p; unsigned sz;
{
	switch(p->mode&RMODE) {
	case	MIMP:
			return;
	case	MIMD:
			genword(p->val, p->sym, sz);
			return;
	case	MDIR:
	case	MINY:
	case	MDRX:
	case	MDRY:
	case	MIND:
	case	MINX:
	case	MSTK:
	case	MDRYL:
	case	MINL:
	case	MDRS:
			genword(p->val,p->sym,1);
			return;
	case	MABS:
	case	MABX:
	case	MABY:
	case	MABI:
			genword(p->val,p->sym,2);
			return;
	case	MABL:
	case	MALX:
	case	MILX:
			genword(p->val,p->sym,3);
			return;
	}
}

