

/***************************************************
 *                                                 *
 *    Macro Assembler				   *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#define DTITLE "wdc65816 Macro V2.0"

/* m6800 supports flexable names */
#define FLEXNAMES
/* m6800 supports the .byte psuedo */
#define BYTEOP
#define LOWHIGH
/* wdc65816 is a byte aligned machine */
#define ALIGN 0
/* wdc65816 address is 16 bits */
#define ADDRSZ 4
#define CPU_TYPE	40
/* Define register types */
#define	REGX	0x1		/*   Register X      */
#define	REGY	0x2		/*   Register Y      */
#define	REGS	0x3		/*   Register S      */

/* Addressing modes */
#define	MIMD	0x01	/* #e	*/ 
#define	MABS	0x02	/* e	*/ 
#define	MDIR	0x03	/* *e	*/ 
#define	MIMP	0x04	/* ...none...	*/
#define	MINY	0x05	/* (e,y)	*/
#define	MDRX	0x06	/* *e,x	*/ 
#define	MDRY	0x07	/* *e,x	*/ 
#define	MABX	0x08	/* e,x	*/  
#define	MABY	0x09	/* e,y	*/ 
#define	MABI	0x0a	/* (e)	*/ 
#define	MIND	0x0b	/* (*e)	*/ 
#define	MINX	0x0c	/* (e),x	*/ 
#define	MSTK	0x0d	/* e,s	*/ 
#define	MDRS	0x0e	/* e,s,y	*/ 
#define	MABL	0x0f	/* >e	*/
#define	MDRYL	0x10	/* >[e,y]	*/ 
#define	MALX	0x11	/* >e,x	*/
#define	MINL	0x12	/* [e]	*/ 
#define MILX	0x13	/* (e,x) */ 


#define  RMODE	0x1f

/* Mode bits for valid */


/* opcode formats */
#define RIGHT	0x80
#define	TBRL	60|RIGHT
#define	TBRS	61|RIGHT
#define	TJMP	62|RIGHT 
#define	TBRK	63|RIGHT
#define	TPSH	64|RIGHT
#define	TGRP0	65|RIGHT
#define	TFLG	66|RIGHT
#define TBIT	67|RIGHT
#define	TZER	68
#define TGRP1	69|RIGHT
#define TGRP2	70|RIGHT
#define	TGP2A	71
#define TSMODE	80
#define TRMODE	81

