/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

struct opcodes optab[] = {
	"adc",		TGRP1,	0x61,
	"and",		TGRP1,	0x21,
	"ascii",	ASCII,	0,
	"asciz",	ASCIZ,	0,
	"asl",		TGP2A,	0x02,
	"bcc",		TBRS,	0x90,
	"bcs",		TBRS,	0xb0,
	"beq",		TBRS,	0xf0,
	"bit",		TGRP0,	0x03,
	"block",	BLOCK,	0,
	"bmi",		TBRS,	0x30,
	"bne",		TBRS,	0xd0,
	"bpl",		TBRS,	0x10,
	"bra",		TBRS,	0x80,
	"brk",		TBRK,	0x00,
	"brl",		TBRL,	0x82,
	"bss",		BSS,	0,
	"bvc",		TBRS,	0x50,
	"bvs",		TBRS,	0x70,
	"byte",		BYTE,	0,
	"clc",		TZER,	0x18,
	"cld",		TZER,	0xd8,
	"cli",		TZER,	0x58,
	"clv",		TZER,	0xb8,
	"cmp",		TGRP1,	0xc1,
	"comm",		COMM,	0,
	"cpx",		TGRP0,	0x05,
	"cpy",		TGRP0,	0x06,
	"data",		DSECT,	0,
	"dec",		TGP2A,	0xc2,
	"dex",		TZER,	0xca,
	"dey",		TZER,	0x88,
	"end",		END,	0,
#ifdef MAXCOND
	"endc",		ENDC,	0,
#endif
	"entry",	ENTRY,	0,
	"eor",		TGRP1,	0x41,
	"equ",		EQU,	0,
	"even",		EVEN,	0,
	"extern",	EXTERN,	0,
	"globl",	GLOBAL,	0,
#ifdef MAXCOND
	"if",		IF,	0,
	"ifd",		IFD,	0,
	"ife",		IFE,	0,
	"iff",		IFF,	0,
	"ifn",		IFN,	0,
	"ift",		IFT,	0,
	"iftf",		IFTF,	0,
	"ifu",		IFU,	0,
#endif
	"inc",		TGP2A,	0xe2,
	"inx",		TZER,	0xe8,
	"iny",		TZER,	0xc8,
	"jmp",		TJMP,	0x4c,
	"jsr",		TJMP,	0x20,
	"lbcc",		TBRS,	0x90,
	"lbcs",		TBRS,	0xb0,
	"lbeq",		TBRS,	0xf0,
	"lbmi",		TBRS,	0x30,
	"lbne",		TBRS,	0xd0,
	"lbpl",		TBRS,	0x10,
	"lbra",		TBRS,	0x80,
	"lbvc",		TBRS,	0x50,
	"lbvs",		TBRS,	0x70,
	"lda",		TGRP1,	0xa1,
	"ldx",		TGRP2,	0xa2,
	"ldy",		TGRP0,	0x0c,
	"longa",	TSMODE,	0x01,
	"longi",	TSMODE,	0x02,
	"lsr",		TGP2A,	0x42,
#ifdef MACASM
	"macro",	MACRO,	0,
	"mend",		MEND,	0,
	"mglb",		MGLB,	0,
	"mgo",		MGO,	0,
	"mlcl",		MLCL,	0,
	"msetc",	MSET,	0,
	"msetl",	MSETL,	0,
#endif 
	"nop",		TZER,	0xea,
	"ora",		TGRP1,	0x01,
	"page",		PAGE,	0,
	"pea",		TPSH,	0xf4,
	"pei",		TPSH,	0xd4,
	"per",		TPSH,	0x62,
	"pha",		TZER,	0x48,
	"phb",		TZER,	0x8b,
	"phd",		TZER,	0x0b,
	"phk",		TZER,	0x4b,
	"php",		TZER,	0x08,
	"phx",		TZER,	0xda,
	"phy",		TZER,	0x5a,
	"pla",		TZER,	0x68,
	"plb",		TZER,	0xab,
	"pld",		TZER,	0x2b,
	"plp",		TZER,	0x28,
	"plx",		TZER,	0xfa,
	"ply",		TZER,	0x7a,
	"print",	PRINT,	0,
	"rep",		TFLG,	0xc2,
	"rol",		TGRP2,	0x0f,
	"ror",		TGRP2,	0x10,
	"rti",		TZER,	0x40,
	"rtl",		TZER,	0x6b,
	"rts",		TZER,	0x60,
	"sbc",		TGRP1,	0xe1,
	"sec",		TZER,	0x38,
	"sed",		TZER,	0xf8,
	"sei",		TZER,	0x78,
	"sep",		TFLG,	0xe2,
	"shorta",	TRMODE,	0xfe,
	"shorti",	TRMODE,	0xfd,
	"space",	SPACE,	0,
	"sta",		TGRP1,	0x81,
	"stitle",	STITLE,	0,
	"stx",		TGRP2,	0x82,
	"sty",		TGRP0,	0x14,
	"stz",		TGRP0,	0x15,
	"tad",		TZER,	0x5b,
	"tas",		TZER,	0x1b,
	"tax",		TZER,	0xaa,
	"tay",		TZER,	0xa8,
	"tda",		TZER,	0x7b,
	"text",		CSECT,	0,
	"title",	TITLE,	0,
	"trb",		TBIT,	0x0c,
	"tsa",		TZER,	0x3b,
	"tsb",		TBIT,	0x1c,
	"tsc",		TZER,	0x3b,
	"tsx",		TZER,	0xba,
	"txa",		TZER,	0x8a,
	"txs",		TZER,	0x9a,
	"txy",		TZER,	0x9b,
	"tya",		TZER,	0x98,
	"tyx",		TZER,	0xbb,
	"wai",		TZER,	0xcb,
	"word",		WORD,	0,
	"xba",		TZER,	0xeb,
	"xce",		TZER,	0xfb,
	};

int opsize = sizeof(optab)/sizeof(struct opcodes);

struct opcodes reglist[] = {
	"x",		0x1,	REG,
	"y",		0x2,	REG,
	"s",		0x3,	REG,
	NULL,		0,	0 };

int grp1fix[] = {
	/* IMD,   ABS,   DIR,   IMP,   INY,   DRX,   DRY,   ABX,   ABY, */
	  0x08,  0x0c,  0x04,  0x00,  0x10,  0x14,  0x00,  0x1c,  0x18,
	/* ABI,  IND,   INX,   STK,   DRS,   ABL,  DRYL,   ALX,   INL,   ILX, */
	  0x00, 0x11,  0x00,  0x00,  0x02,  0x0e,  0x16,  0x1e,  0x06,  0x00
	};


int grp2fix[] = {
	/* IMD,   ABS,   DIR,   IMP,   INY,   DRX,   DRY,   ABX,   ABY, */
	  0x00,  0x0c,  0x04,  0x08,  0x00,  0x14,  0x00,  0x1c,  0x00,
	/* ABI,  IND,   INX,   STK,   DRS,   ABL,  DRYL,   ALX,   INL,   ILX, */
	  0x00, 0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00
	};


int grp0fix[] = {
	/* IMD,   ABS,   DIR,   IMP,   INY,   DRX,   DRY,   ABX,   ABY, */
	  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
	/* ABI,  IND,   INX,   STK,   DRS,   ABL,  DRYL,   ALX,   INL,   ILX, */
	  0x00, 0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00
	};


