

/***************************************************
 *                                                 *
 *    Macro Assembler				   *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#define DTITLE "Z8000 Macro V2.0"

/* Z8000 supports flexable names */
#define FLEXNAMES
/* Z8000 supports the .byte psuedo */
#define BYTEOP
/* Z8000 is a word aligned machine */
#define ALIGN 1
/* Z8000 is a 16 bit address machine */
#define ADDRSZ 4
#define CPU_TYPE	20
/* Define register types */
#define WREG	32		/* reg's Rx */
#define BREG	31		/* reg's RHx & RLx */
#define	LREG	33		/* reg's RRx */
#define QREG	37		/* reg's RQx */
#define CREG	34		/* condition codes */
#define IREG	35		/* irq flags */
#define SREG	36		/* control registers names */

/* Addressing modes */
#define  MIND	0x00		/* @reg */
#define  MINX	0x10		/* off(reg) */
#define  MREG	0x20		/* reg */
#define  MCON	0x30		/* cond */
#define  MIMD	0x40		/* #reg */
#define  MDIR	0x50		/* off */
#define	 MBAS	0x60		/* reg(reg) */
#define  MSPC 	0x70		/* control reg */
#define  MIRQ	0x80		/* interupt flag */
#define  RMODE	0xF0

/* Address mode masks */
#define  VIND	0000001
#define  VINX	0000002
#define  VREG	0000004
#define  VCON	0000010
#define  VIMD	0000020
#define  VDIR	0000040
#define  VBAS 	0000100
#define  VSPC	0000200

#define  VSRC	VIND|VINX|VREG|VIMD|VDIR
#define  VDST	VIND|VINX|VREG|VDIR

/* Opcode types */
#define	TBIT	60
#define	TBRA	61
#define	TCMP	62
#define	TDIE	63
#define	TDJN	64
#define	TFLG	65
#define	TINC	66
#define	TJMP	67
#define	TLDA	68
#define	TLDC	69
#define	TLDM	70
#define	TLDR	71
#define	TLDX	72
#define	TMOV	73
#define	TONE	74
#define	TPOP	75
#define	TREG	76
#define	TREL	77
#define	TRET	78
#define	TROL	79
#define	TSC	80
#define	TSGN	81
#define	TSHF	82
#define	TTWO	83
#define	TZER	84
