/***************************************************
 *                                                 *
 *    Macro Assembler			           *
 *                                                 *
 *    Written by Richard Cornwell                  *
 *               3/20/86                           *
 *                                                 *
 ***************************************************/

#include "macro.h"

struct opcodes optab[] = {
	"adc",		TREG,	0xb500,
	"adcb",		TREG,	0xb400,
	"add",		TTWO,	0x0100,
	"addb",		TTWO,	0x0000,
	"addl",		TTWO,	0x1600,
	"and",		TTWO,	0x0700,
	"andb",		TTWO,	0x0600,
	"ascii",	ASCII,	0,
	"asciz",	ASCIZ,	0,
	"bit",		TBIT,	0x2700,
	"bitb",		TBIT,	0x2600,
	"bss",		BSS,	0,
	"byte",		BYTE,	0,
	"call",		TJMP,	0x1f00,
	"calr",		TREL,	0xd000,
	"clr",		TONE,	0x0d08,
	"clrb",		TONE,	0x0c08,
	"com",		TONE,	0x0d00,
	"comb",		TONE,	0x0c00,
	"comflg",	TFLG,	0x8d05,
	"comm",		COMM,	0,
	"cp",		TCMP,	0x0b00,
	"cpb",		TCMP,	0x0a00,
	"cpd",		TMOV,	0xbb08,
	"cpdb",		TMOV,	0xba08,
	"cpdr",		TMOV,	0xbb0c,
	"cpdrb",	TMOV,	0xba0c,
	"cpi",		TMOV,	0xbb00,
	"cpib",		TMOV,	0xba00,
	"cpir",		TMOV,	0xbb04,
	"cpirb",	TMOV,	0xba04,
	"cpl",		TCMP,	0x1000,
	"cpsd",		TMOV,	0xbb0a,
	"cpsdb",	TMOV,	0xba0a,
	"cpsdr",	TMOV,	0xbb0e,
	"cpsdrb",	TMOV,	0xba0e,
	"cpsi",		TMOV,	0xbb02,
	"cpsib",	TMOV,	0xba02,
	"cpsir",	TMOV,	0xbb06,
	"cpsirb",	TMOV,	0xba06,
	"dab",		TSGN,	0xb000,
	"data",		DSECT,	0,
	"dbjnz",	TDJN,	0xf000,
	"dec",		TINC,	0x2b00,
	"decb",		TINC,	0x2a00,
	"di",		TDIE,	0x7c00,
	"div",		TREG,	0x1b00,
	"divl",		TREG,	0x1a00,
	"djnz",		TDJN,	0xf080,
	"ds",		BLOCK,	0,
	"ei",		TDIE,	0x7c04,
	"end",		END,	0,
#ifdef MAXCOND
	"endc",		ENDC,	0,
#endif
	"entry",	ENTRY,	0,
	"equ",		EQU,	0,
	"even",		EVEN,	0,
	"ex",		TREG,	0x2d00,
	"exb",		TREG,	0x2c00,
	"extern",	EXTERN,	0,
	"exts",		TSGN,	0xb10a,
	"extsb",	TSGN,	0xb100,
	"extsl",	TSGN,	0xb107,
	"globl",	GLOBAL,	0,
	"halt",		TZER,	0x7a00,
#ifdef MAXCOND
	"if",		IF,	0,
	"ifd",		IFD,	0,
	"ife",		IFE,	0,
	"iff",		IFF,	0,
	"ifn",		IFN,	0,
	"ift",		IFT,	0,
	"iftf",		IFTF,	0,
	"ifu",		IFU,	0,
#endif
	"inc",		TINC,	0x2900,
	"incb",		TINC,	0x2800,
	"iret",		TZER,	0x7b00,
	"jp",		TJMP,	0x1e00,
	"jr",		TBRA,	0xe000,
	"ld",		TLDX,	0x2100,
	"lda",		TLDA,	0x3600,
	"ldar",		TLDA,	0x3400,
	"ldb",		TLDX,	0x2000,
	"ldctl",	TLDC,	0x7d00,
	"ldctlb",	TLDC,	0x8c00,
	"ldd",		TMOV,	0xbb09,
	"lddb",		TMOV,	0xba09,
	"lddr",		TMOV,	0xbb0d,
	"lddrb",	TMOV,	0xba0d,
	"ldi",		TMOV,	0xbb01,
	"ldib",		TMOV,	0xba01,
	"ldir",		TMOV,	0xbb05,
	"ldirb",	TMOV,	0xba05,
	"ldl",		TLDX,	0x1400,
	"ldm",		TLDM,	0x1c01,
	"ldps",		TJMP,	0x3900,
	"ldr",		TLDR,	0x3100,
	"ldrb",		TLDR,	0x3000,
	"ldrl",		TLDR,	0x3500,
#ifdef MACASM
	"macro",	MACRO,	0,
#endif
	"mbit",		TZER,	0x7b0a,
#ifdef MACASM
	"mend",		MEND,	0,
	"mglb",		MGLB,	0,
	"mgo",		MGO,	0,
	"mlcl",		MLCL,	0,
#endif
	"mres",		TZER,	0x7b09,
	"mreq",		TSGN,	0x7b0d,
	"mset",		TZER,	0x7b08,
#ifdef MACASM
	"msetc",	MSET,	0,
	"msetl",	MSETL,	0,
#endif 
	"mult",		TTWO,	0x1900,
	"multl",	TTWO,	0x1800,
	"neg",		TONE,	0x0d02,
	"negb",		TONE,	0x0c02,
	"not",		TZER,	0x8d07,
	"or",		TTWO,	0x0500,
	"orb",		TTWO,	0x0400,
	"page",		PAGE,	0,
	"pop",		TPOP,	0x1700,
	"popl",		TPOP,	0x1500,
	"print",	PRINT,	0,
	"push",		TPOP,	0x1300,
	"pushl",	TPOP,	0x1100,
	"res",		TBIT,	0x2300,
	"resb",		TBIT,	0x2200,
	"resflg",	TFLG,	0x8d03,
	"ret",		TRET,	0x9e00,
	"rl",		TROL,	0xb300,
	"rlb",		TROL,	0xb200,
	"rlc",		TROL,	0xb308,
	"rlcb",		TROL,	0xb208,
	"rldb",		TREG,	0xbe00,
	"rr",		TROL,	0xb304,
	"rrb",		TROL,	0xb204,
	"rrc",		TROL,	0xb30c,
	"rrcb",		TROL,	0xb20c,
	"rrdb",		TREG,	0xbc00,
	"sbc",		TREG,	0xb700,
	"sbcb",		TREG,	0xb600,
	"sc",		TSC,	0x7f00,
	"sda",		TSHF,	0xb30b,
	"sdab",		TSHF,	0xb20b,
	"sdal",		TSHF,	0xb30f,
	"sdl",		TSHF,	0xb303,
	"sdlb",		TSHF,	0xb203,
	"sdll",		TSHF,	0xb307,
	"set",		TBIT,	0x2500,
	"setb",		TBIT,	0x2400,
	"setflg",	TFLG,	0x8d01,
	"sla",		TSHF,	0xb309,
	"slab",		TSHF,	0xb209,
	"slal",		TSHF,	0xb30d,
	"sll",		TSHF,	0xb301,
	"sllb",		TSHF,	0xb201,
	"slll",		TSHF,	0xb305,
	"space",	SPACE,	0,
	"sra",		TSHF,	0xb319,
	"srab",		TSHF,	0xb219,
	"sral",		TSHF,	0xb31d,
	"srl",		TSHF,	0xb311,
	"srlb",		TSHF,	0xb211,
	"srll",		TSHF,	0xb315,
	"stitle",	STITLE,	0,
	"sub",		TTWO,	0x0300,
	"subb",		TTWO,	0x0200,
	"subl",		TTWO,	0x1200,
	"tcc",		TJMP,	0xaf00,
	"tccb",		TJMP,	0xae00,
	"test",		TONE,	0x0d04,
	"testb",	TONE,	0x0c04,
	"testl",	TONE,	0x1c08,
	"text",		CSECT,	0,
	"title",	TITLE,	0,
	"trdb",		TMOV,	0xb808,
	"trdrb",	TMOV,	0xb80c,
	"trib",		TMOV,	0xb800,
	"trirb",	TMOV,	0xb804,
	"trtdb",	TMOV,	0xb80a,
	"trtdrb",	TMOV,	0xb80e,
	"trtib",	TMOV,	0xb802,
	"trtirb",	TMOV,	0xb806,
	"tset",		TONE,	0x0d06,
	"tsetb",	TONE,	0x0c06,
	"word",		WORD,	0,
	"xor",		TTWO,	0x0900,
	"xorb",		TTWO,	0x0800,
	};

int opsize = sizeof(optab)/sizeof(struct opcodes);

#define WR	((WREG<<8))
#define BR	((BREG<<8))
#define LR	((LREG<<8))
#define QR	((QREG<<8))
#define CR	((CREG<<8))
#define SR	((SREG<<8))
#define IR	((IREG<<8))

struct opcodes reglist[] = {
	"r0",		WR|0,	REG,
	"r1",		WR|1,	REG,
	"r2",		WR|2,	REG,
	"r3",		WR|3,	REG,
	"r4",		WR|4,	REG,
	"r5",		WR|5,	REG,
	"r6",		WR|6,	REG,
	"r7",		WR|7,	REG,
	"r8",		WR|8,	REG,
	"r9",		WR|9,	REG,
	"r10",		WR|10,	REG,
	"r11",		WR|11,	REG,
	"r12",		WR|12,	REG,
	"r13",		WR|13,	REG,
	"r14",		WR|14,	REG,
	"fp",		WR|14,	REG,
	"r15",		WR|15,	REG,
	"sp",		WR|15,	REG,
	"rh0",		BR|0,	REG,
	"rl0",		BR|1,	REG,
	"rh1",		BR|2,	REG,
	"rl1",		BR|3,	REG,
	"rh2",		BR|4,	REG,
	"rl2",		BR|5,	REG,
	"rh3",		BR|6,	REG,
	"rl3",		BR|7,	REG,
	"rh4",		BR|8,	REG,
	"rl4",		BR|9,	REG,
	"rh5",		BR|10,	REG,
	"rl5",		BR|11,	REG,
	"rh6",		BR|12,	REG,
	"rl6",		BR|13,	REG,
	"rh7",		BR|14,	REG,
	"rl7",		BR|15,	REG,
	"rr0",		LR|0,	REG,
	"rr2",		LR|2,	REG,
	"rr4",		LR|4,	REG,
	"rr6",		LR|6,	REG,
	"rr8",		LR|8,	REG,
	"rr10",		LR|10,	REG,
	"rr12",		LR|12,	REG,
	"rr14",		LR|14,	REG,
	"rq0",		QR|0,	REG,
	"rq4",		QR|4,	REG,
	"rq8",		QR|8,	REG,
	"rq12",		QR|12,	REG,
	"lt",		CR|1,	REG,
	"le",		CR|2,	REG,
	"ule",		CR|3,	REG,
	"ov",		CR|4,	REG,
	"pe",		CR|4,	REG,
	"p",		CR|4,	REG,
	"mi",		CR|5,	REG,
	"s",		CR|5,	REG,
	"z",		CR|6,	REG,
	"eq",		CR|6,	REG,
	"c",		CR|7,	REG,
	"ult",		CR|7,	REG,
	"ge",		CR|9,	REG,
	"gt",		CR|10,	REG,
	"ugt",		CR|11,	REG,
	"nov",		CR|12,	REG,
	"po",		CR|12,	REG,
	"pl",		CR|13,	REG,
	"nz",		CR|14,	REG,
	"ne",		CR|14,	REG,
	"nc",		CR|15,	REG,
	"uge",		CR|15,	REG,
	"vi",		IR|2,	REG,
	"nvi",		IR|1,	REG,
	"flags",	SR|1,	REG,
	"fcw",		SR|2,	REG,
	"refresh",	SR|3,	REG,
	"psapoff",	SR|5,	REG,
	"nspoff",	SR|7,	REG,
	NULL,		0,	0 };
